local player, realm, user;


function isempty(s)
  return s == nil or s == '';
end

function p(t)
	DEFAULT_CHAT_FRAME:AddMessage(t);
end

local function has_value (tab, val)
	if(tab == nil) then return false end;
    for index, value in ipairs(tab) do
        if value == val then
            return true;
        end;
    end;

    return false;
end

function UsedInRecipe_OnLoad(self)
	if (isempty(uirItemDB)) then
		uirItemDB = {};
	end
	if (isempty(uirReciDB)) then
		uirReciDB = {};
	end
	if (isempty(uirTradDB)) then
		uirTradDB = {};
	end
	
	self:RegisterEvent("TRADE_SKILL_UPDATE");
	self:RegisterEvent("TRADE_SKILL_SHOW");
	self:RegisterEvent("CRAFT_SHOW");
	self:RegisterEvent("CRAFT_UPDATE");
	--self:RegisterEvent("PLAYER_LOGIN");
	player, _ = UnitName("player");
	realm = GetRealmName();
	user = player .. "-" .. realm;

	p("UsedInRecipe loaded.");
end;

function UsedInRecipe_OnEvent(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
	if (event == "TRADE_SKILL_UPDATE" or event == "TRADE_SKILL_SHOW") then
		UsedInRecipe_UpdateList("trade");
	elseif (event == "CRAFT_SHOW" or event == "CRAFT_UPDATE") then
		UsedInRecipe_UpdateList("craft");
	end;
end;

function UsedInRecipe_UpdateList(window)
	local name, type;
	local tradeskillName, currentLevel, maxLevel, skillLineModifier;
	local x;
	if(window == "craft") then
		tradeskillName = GetCraftSkillLine(1);
		x = GetNumCrafts();
	else
		tradeskillName, currentLevel, maxLevel, skillLineModifier = GetTradeSkillLine();
		x = GetNumTradeSkills();
	end
	
	if(uirTradDB[realm] == nil) then uirTradDB[realm] = {} end;
	if(uirTradDB[realm][player] == nil) then uirTradDB[realm][player] = {} end;
	if(not has_value(uirTradDB[realm][player], tradeskillName)) then
		table.insert(uirTradDB[realm][player], tradeskillName);
	end;
	
	
	
	for i=1,x do
		if(window == "craft") then
			name, _, type, _, _, _, _ = GetCraftInfo(i);
		else
			name, type, _, _, _, _ = GetTradeSkillInfo(i);
		end;

		if (name and type ~= "header") then
			if(uirReciDB[realm] == nil) then uirReciDB[realm] = {} end;
			if(uirReciDB[realm][player] == nil) then uirReciDB[realm][player] = {} end;
			uirReciDB[realm][player][name] = type;
			
			local numReagents;
			if(window == "craft") then
				numReagents = GetCraftNumReagents(i);
			else
				numReagents = GetTradeSkillNumReagents(i);
			end;
			for ii=1, numReagents, 1 do
				local reagentName, reagentTexture, reagentCount, playerReagentCount;
				if(window == "craft") then
					reagentName, reagentTexture, reagentCount, playerReagentCount = GetCraftReagentInfo(i, ii);
					p(reagentName);
				else
					reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(i, ii);
				end;
				
				if(reagentName ~= nil) then
					if(uirItemDB[tradeskillName] == nil) then uirItemDB[tradeskillName] = {} end;
					if(uirItemDB[tradeskillName][reagentName] == nil) then uirItemDB[tradeskillName][reagentName] = {} end;
					if(not has_value(uirItemDB[tradeskillName][reagentName], name)) then
						table.insert(uirItemDB[tradeskillName][reagentName], name);
						table.sort(uirItemDB[tradeskillName][reagentName]);
					end;
				end;
			end;
		end;
	end;
end;

GameTooltip:HookScript("OnTooltipSetItem",function(self)
	local name = self:GetItem();
	local col = "|cffff0000";
	local found = false;
	local txt = "";
	local line;
	local players = {};
	local shifted = IsShiftKeyDown();
	
	if(uirTradDB[realm] == nil) then uirTradDB[realm] = {} end;
	if(uirTradDB[realm][player] == nil) then uirTradDB[realm][player] = {} end;
	
	if(shifted) then
		for k,v in pairs(uirReciDB[realm]) do
			table.insert(players, k);
		end
	else
		players = {player};
	end

	for tradeskillName, reagentName in pairs(uirItemDB) do
		for ii=1,#players do
			if(has_value(uirTradDB[realm][players[ii]], tradeskillName)) then
				line = 0;
				if (uirItemDB[tradeskillName][name] ~= nil) then
					p("Used in a recipe!");
					found = true;
					if(line == 0) then
						txt = txt .. "\n[" .. tradeskillName .. "] ";
						if(shifted or players[ii] ~= player) then
							txt = txt .. "|cff1eff00" .. players[ii] .. "|r";
						end;
					end;
					line = line + 1;
					for i=1, #uirItemDB[tradeskillName][name] do
						col = "|cffff0000";
						local k = uirItemDB[tradeskillName][name][i];
						if(uirReciDB[realm] == nil) then uirReciDB[realm] = {} end;
						if(uirReciDB[realm][players[ii]] == nil) then uirReciDB[realm][players[ii]] = {} end;
						if(uirReciDB[realm][players[ii]][k] ~= nil) then
							if(uirReciDB[realm][players[ii]][k] == "trivial") then
								col = "|cff9d9d9d";
							elseif(uirReciDB[realm][players[ii]][k] == "easy") then
								col = "|cff1eff00";
							elseif(uirReciDB[realm][players[ii]][k] == "medium") then
								col = "|cffffff00";
							elseif(uirReciDB[realm][players[ii]][k] == "optimal") then
								col = "|cffff8000";
							end
						end;
						txt = txt .. ("\n - " .. col .. k .. "|r");
					end;
				end;
			end;
		end;
	end;
	if(found) then
		self:AddLine(txt);
	--else
	--	self:AddLine("|cffff0000Not used in any known recipes!|r");
	end;
end);